#lang racket

(require math/base)

;;;; 7. cvičenie z predmetu 2-AIN-285 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.10.1
;;;; Dátum: 16.4.2018
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-285-lisp/1718ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - imperatívne programovanie.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 6
;;;; Odovzdať do 22.4.2018 (nedeľa) do 12:00.
;;;; Projekty odovzdať do 29.4.2018 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

(define (random-integer-mlist length m n)
  (define (loop length acc)
    (if (> length 0)
        (loop (- length 1) (mcons (random-integer m n) acc))
        acc))
  (loop length null))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

(require scheme/mpair)

;;; Kapitola. Imperatívne a objektovo-orientované programovanie.

;;; Sekcia. Priradenia a lokálny stav.

;; Úloha. Vyriešte príklady, ktoré sa nachádzajú na začiatku podsekcie 3.3.1 v [1].

(define balance ...)
(define (withdraw amount) ...)
(define new-withdraw ...)
(define (make-withdraw balance) ...)
(define (make-account balance) ...)

;; (1 bod)
;; Úloha. Vyriešte cvičenie 3.3 v [1].

(define (make-account-with-password balance password) ...)

;; (define acc (make-account-with-password 100 'secret-password))
;; ((acc 'secret-password 'withdraw) 40)
;; ((acc 'some-other-password 'deposit) 50)

;;; Sekcia. Modifikovateľné dvojice.

;; (1 bod)
;; Úloha. Zostrojte procedurálnu implementáciu modifikovateľných dvojíc.
;;   Návod. Pozri odsek "Mutation is just assignment" podsekcie 3.3.1 v [1].

(define (cons x y) ...)
(define (car z) ...)
(define (cdr z) ...)
(define (set-cdr! z new-value) ...)
(define (set-car! z new-value) ...)

;; (let ([z (cons 1 2)]) (writeln (car z)) (writeln (cdr z)))
;; (let ([z (cons 1 2)]) (set-car! z 3) (set-cdr! z 4) (writeln (car z)) (writeln (cdr z)))

;; Úloha. Vyriešte cvičenie 3.20 v [1].

;;; Podsekcia. Modifikovateľné zoznamy.

;; [Lisp] Pozri modul scheme/mpair:
;;   - mcons, mcar, mcdr, set-mcar!, set-mcdr!,
;;   - mlist, mappend, mappend!, mreverse, mreverse!.

;; Úloha. Zostrojte program, ktorý zreťazí dva zoznamy.

(define (mappend xs ys) ...)

;; (mappend (mlist) (mlist 4 5))
;; (mappend (mlist 1) (mlist 4 5))
;; (mappend (mlist 1 2) (mlist 4 5))
;; (mappend (mlist 1 2 3) (mlist 4 5))

;; Úloha. Nájdite imperatívnu implementáciu operácie mappend, ktorá nevyužíva
;; konštruktor mcons.
;;   Návod. Pozri cvičenie 3.12 v [1].

(define (mappend! xs ys) ...)

;; (mappend! (mlist) (mlist 4 5))
;; (mappend! (mlist 1) (mlist 4 5))
;; (mappend! (mlist 1 2) (mlist 4 5))
;; (mappend! (mlist 1 2 3) (mlist 4 5))

;; (let ([xs (mlist)]) (writeln xs) (writeln (mappend! xs (mlist 4 5))) (writeln xs))
;; (let ([xs (mlist)]) (writeln xs) (writeln (set! xs (mappend! xs (mlist 4 5)))) (writeln xs))

;; (let ([xs (mlist 1 2 3)]) (writeln xs) (writeln (mappend! xs (mlist 4 5))) (writeln xs))
;; (let ([xs (mlist 1 2 3)]) (writeln xs) (writeln (set! xs (mappend! xs (mlist 4 5)))) (writeln xs))

;; Úloha. Nájdite iteratívnu implementáciu operácie, ktorá obracia poradie
;; prvkov v zozname.

;(define (mreverse xs) ...)

;; (mreverse (mlist))
;; (mreverse (mlist 1))
;; (mreverse (mlist 1 2))
;; (mreverse (mlist 1 2 3 4 5))

;; (1 bod)
;; Úloha. Nájdite imperatívnu implementáciu operácie mreverse, ktorá nevyužíva
;; konštruktor mcons.

(define (mreverse! xs) ...)

;; (mreverse! (mlist))
;; (mreverse! (mlist 1))
;; (mreverse! (mlist 1 2))
;; (mreverse! (mlist 1 2 3 4 5))

;; (let (( xs (mlist 1 2 3 4 5))) (writeln xs) (writeln (mreverse! xs)) (writeln xs))
;; (let (( xs (mlist 1 2 3 4 5))) (writeln xs) (writeln (set! xs (mreverse! xs))) (writeln xs))

;;; Sekcia. Abstraktné dátové typy.

;;; Podsekcia. Abstraktný dátový typ front.

;; Pozri tiež podsekciu 3.3.2 v [1].

;; Neverejné metódy.

(define (front-ptr queue) ...)
(define (rear-ptr queue) ...)
(define (set-front-ptr! queue item) ...)
(define (set-rear-ptr! queue item) ...)

;; Verejné metódy.

(define (make-queue) ...)
(define (empty-queue? queue) ...)
(define (front-queue queue) ...)
(define (insert-queue! queue item) ...)
(define (delete-queue! queue) ...)

;; Úloha. Vyriešte cvičenie 3.21 v [1].

;; (projekt 3 body)
;; Úloha. Implementujte algoritmus triedenia zoznamov pomocou dvoch frontov:
;; - Najprv sa celý zoznam vloží do prvého frontu pomocou operácie mlist->queue.
;; - Prvky prvého frontu sa vkladajú postupne do druhého frontu tak, aby tento
;;   sa stal usporiadaný. To občas vyžaduje, aby sa prvky druhého frontu
;;   cyklicky preusporiadali.
;; - Výsledný utriedený zoznam sa vyberie z druhého frontu pomocou operácie
;;   queue->mlist.
;; V implementácií používajte len verejné operácie pre ADT front.

(define (mlist->queue items) ...)

(define (sort-queue queue1) ...)

(define (queue->mlist queue) ...)

(define (sort-mlist items) (queue->mlist (sort-queue (mlist->queue items))))

;; (mlist->queue (mlist 1 2 3 4 5))
;; (queue->mlist (mlist->queue (mlist 1 2 3 4 5)))

;; (sort-queue (mlist->queue (mlist)))
;; (sort-queue (mlist->queue (mlist 1)))
;; (sort-queue (mlist->queue (mlist 2 1)))
;; (sort-queue (mlist->queue (mlist 2 4 3 1 5)))

;; (let ([xs (random-integer-mlist 20 1 10)]) (begin (writeln xs) (sort-mlist xs)))

;; Úloha. Vyriešte cvičenie 3.21 v [1].

(define (print-queue queue) ...)

;; (print-queue (mlist->queue (mlist 1 2 3 4 5)))

;; (projekt 3 body)
;; Úloha. Vyriešte cvičenie 3.22 v [1].

(define (make-queue2)
  (let ([front-ptr ...]
        [rear-ptr ...])
    (define (set-front-ptr! item) ...)
    (define (set-rear-ptr! item) ...)
    (define (empty-queue?) ...)
    (define (front-queue) ...)
    (define (insert-queue! item) ...)
    (define (delete-queue!) ...)
    (define (print-queue) ...)
    (define (dispatch m)
      (cond ((eq? m '...) ...)
            (else (error "Unknown request -- MAKE-QUEUE2"
                         m))))
    dispatch))

;; (define q1 (make-queue2))
;; (begin ((q1 'insert-queue!) 1) ((q1 'print-queue)))
;; (begin ((q1 'insert-queue!) 2) ((q1 'print-queue)))
;; (begin ((q1 'delete-queue!)) ((q1 'print-queue)))
;; (begin ((q1 'delete-queue!)) ((q1 'print-queue)))
